genotype = {}

CODE_MAX = 4
MUTATION_RATE = 0.2

function genotype.generate(length)
	length = length or 10
	local genes = ''
	for i=1, length do
		genes = genes .. math.floor(math.random() * CODE_MAX+1)
	end
	return genes
end

function genotype.mutate(genotype)
	local genes = ''
	for i=1, #genotype do
		code = genotype:sub(i,i)
		if math.random() < MUTATION_RATE then
			code = ((code+1) % CODE_MAX)+1
		end
		if math.random() < MUTATION_RATE/2 then
			genes = genes..math.floor(math.random() * CODE_MAX+1)
		end
		if math.random() > MUTATION_RATE then
			genes = genes..code
		end
	end
	return genes
end
