function Circle(x, y, radius)
	local circle = {
		x = x,
		y = y,
		radius = radius
	}

	function circle:intersects(c)
		local dx = c.x - self.x
		local dy = c.y - self.y
		return dx*dx+dy*dy < self.radius*self.radius + c.radius*c.radius
	end

	function circle:log()
		print(self.x, self.y, self.radius)
	end

	return circle
end
